/*
*   CVTARC  --	Program to convert between the Ultrix (Unix) STREAM_LF
*		format and the VMS variable, 510 byte max, record format
*		used to store ARC files on VMS.  
*/

#include    <stdio.h>
#include    <file.h>
#define BUFSIZ 510

main(argc, argv)
int    argc;
char   *argv[];
{
    FILE *f1, *f2;
    int f;
    int i;
    char buf[BUFSIZ];
    char *bufp = buf;
    char *outf;
    
    if (argc == 3) {
	outf = (char *) malloc(strlen(argv[2]));
	strcpy(outf,argv[2]);
    }
    else if ( argc == 4) {
	outf = (char *) malloc(strlen(argv[3]));
	strcpy(outf,argv[3]);
    }

    if (*argv[1] == 'u' && (argc == 3 || argc == 4)) {
	if((f1 = fopen(argv[2], "r+")) == NULL) {
	    perror("CVTARC: ");
	    exit(2);
	}
	if((f2 = fopen(outf, "w+")) == NULL) {
	    perror("CVTARC: ");
	    exit(2);
	}
	while ((i = fgetc(f1)) != EOF)
	    fputc((char)i, f2);
	fclose(f1);
	fclose(f2);
    }
    else if (*argv[1] == 'v' && (argc == 3 || argc == 4)) {
	if((f1 = fopen(argv[2], "r+")) == NULL) {
	    perror("CVTARC: ");
	    exit(2);
	}
	sprintf(buf,"mrs=%d",BUFSIZ);
	if((f = open(outf, O_WRONLY|O_CREAT, 0,
		     "rfm=var",buf)) == -1) {
	    perror("CVTARC: ");
	    exit(2);
	}
	while ((i = fgetc(f1)) != EOF) {
	    if (bufp == buf + BUFSIZ) {
		write(f, buf, BUFSIZ);
		bufp = buf;
	    }
	    *bufp++ = (char) i;
	}
	write(f, buf, bufp-buf);
	fclose(f1);
	close(f);
    }
    else {
         printf("Usage: CVTARC {uv} <from file> [<to file>]\n");
         printf("Where:   u   = convert to STREAM_LF\n");
         printf("         v   = convert to fixed length records\n");
    }
}
